Index: NEMO/trunk/src/OCE/ICB/icbrst.F90
===================================================================
--- NEMO/trunk/src/OCE/ICB/icbrst.F90	(revision 13030)
+++ NEMO/trunk/src/OCE/ICB/icbrst.F90	(revision 13062)
@@ -192,5 +192,5 @@
       CHARACTER(len=256)     :: cl_path
       CHARACTER(len=256)     :: cl_filename
-      CHARACTER(len=256)     :: cl_kt
+      CHARACTER(len=8  )     :: cl_kt
       CHARACTER(LEN=12 )     :: clfmt            ! writing format
       TYPE(iceberg), POINTER :: this
@@ -213,11 +213,11 @@
          ! file name
          WRITE(cl_kt, '(i8.8)') kt
-         cl_filename = TRIM(cexper)//"_"//TRIM(ADJUSTL(cl_kt))//"_"//TRIM(cn_icbrst_out)
+         cl_filename = TRIM(cexper)//"_"//cl_kt//"_"//TRIM(cn_icbrst_out)
          IF( lk_mpp ) THEN
             idg = MAX( INT(LOG10(REAL(MAX(1,jpnij-1),wp))) + 1, 4 )          ! how many digits to we need to write? min=4, max=9
             WRITE(clfmt, "('(a,a,i', i1, '.', i1, ',a)')") idg, idg          ! '(a,a,ix.x,a)'
-            WRITE(cl_filename,clfmt) TRIM(cl_filename), '_', narea-1, '.nc'
+            WRITE(cl_filename,  clfmt) TRIM(cl_filename), '_', narea-1, '.nc'
          ELSE
-            WRITE(cl_filename,'(A,".nc")') TRIM(cl_filename)
+            WRITE(cl_filename,'(a,a)') TRIM(cl_filename),               '.nc'
          ENDIF
 
Index: NEMO/trunk/src/OCE/ICB/icbtrj.F90
===================================================================
--- NEMO/trunk/src/OCE/ICB/icbtrj.F90	(revision 13030)
+++ NEMO/trunk/src/OCE/ICB/icbtrj.F90	(revision 13062)
@@ -66,5 +66,5 @@
       CHARACTER(len=80)      ::   cl_filename
       CHARACTER(LEN=12)      ::   clfmt            ! writing format
-      CHARACTER(LEN=20)      ::   cldate_ini, cldate_end
+      CHARACTER(LEN=8 )      ::   cldate_ini, cldate_end
       TYPE(iceberg), POINTER ::   this
       TYPE(point)  , POINTER ::   pt
@@ -82,11 +82,11 @@
 
       ! define trajectory output name
-      cl_filename = 'trajectory_icebergs_'//TRIM(ADJUSTL(cldate_ini))//'-'//TRIM(ADJUSTL(cldate_end))
+      cl_filename = 'trajectory_icebergs_'//cldate_ini//'-'//cldate_end
       IF ( lk_mpp ) THEN
          idg = MAX( INT(LOG10(REAL(MAX(1,jpnij-1),wp))) + 1, 4 )          ! how many digits to we need to write? min=4, max=9
          WRITE(clfmt, "('(a,a,i', i1, '.', i1, ',a)')") idg, idg          ! '(a,a,ix.x,a)'
-         WRITE(cl_filename,clfmt) TRIM(cl_filename), '_', narea-1, '.nc'
+         WRITE(cl_filename,  clfmt) TRIM(cl_filename), '_', narea-1, '.nc'
       ELSE
-         WRITE(cl_filename,'(A,".nc")') TRIM(cl_filename)
+         WRITE(cl_filename,'(a,a)') TRIM(cl_filename),               '.nc'
       ENDIF
       IF( lwp .AND. nn_verbose_level >= 0 )   WRITE(numout,'(2a)') 'icebergs, icb_trj_init: creating ',TRIM(cl_filename)
Index: NEMO/trunk/src/OCE/IOM/iom_def.F90
===================================================================
--- NEMO/trunk/src/OCE/IOM/iom_def.F90	(revision 13030)
+++ NEMO/trunk/src/OCE/IOM/iom_def.F90	(revision 13062)
@@ -33,5 +33,5 @@
    INTEGER, PARAMETER, PUBLIC ::   jpmax_vars   = 1200 !: maximum number of variables in one file
    INTEGER, PARAMETER, PUBLIC ::   jpmax_dims   =  4   !: maximum number of dimensions for one variable
-   INTEGER, PARAMETER, PUBLIC ::   jpmax_digits =  5   !: maximum number of digits for the cpu number in the file name
+   INTEGER, PARAMETER, PUBLIC ::   jpmax_digits =  9   !: maximum number of digits for the cpu number in the file name
 
 
Index: NEMO/trunk/src/OCE/LBC/lib_mpp.F90
===================================================================
--- NEMO/trunk/src/OCE/LBC/lib_mpp.F90	(revision 13030)
+++ NEMO/trunk/src/OCE/LBC/lib_mpp.F90	(revision 13062)
@@ -1221,5 +1221,5 @@
       CHARACTER(LEN=10) ::   clfmt            ! writing format
       INTEGER           ::   iost
-      INTEGER           ::   idg  ! number of digits
+      INTEGER           ::   idg              ! number of digits
       !!----------------------------------------------------------------------
       !