Index: /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/CONFIG/SHARED/namelist_ref
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 13071)
+++ /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 13072)
@@ -1087,4 +1087,5 @@
    sn_cfctl%l_oceout  = .FALSE. ! that  all areas report.
    sn_cfctl%l_layout  = .FALSE. !
+   sn_cfctl%l_sbcisf  = .FALSE. !
    sn_cfctl%l_mppout  = .FALSE. !
    sn_cfctl%l_mpptop  = .FALSE. !
Index: /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/ICB/icbclv.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/ICB/icbclv.F90	(revision 13071)
+++ /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/ICB/icbclv.F90	(revision 13072)
@@ -69,5 +69,5 @@
       ! nn_coupled_iceshelf_fluxes uninitialised unless lk_oasis=true
       IF( nn_coupled_iceshelf_fluxes .gt. 0 ) THEN
-        ll_write = ((MOD( kt, sn_cfctl%ptimincr ) == 0) .OR. ( kt == nitend )) .AND. lwp
+        ll_write = ((MOD( kt, sn_cfctl%ptimincr ) == 0) .OR. ( kt == nitend )) .AND. lwp .AND. sn_cfctl%l_sbcisf
         ! Adjust total calving rates so that sum of iceberg calving and iceshelf melting in the northern
         ! and southern hemispheres equals rate of increase of mass of greenland and antarctic ice sheets
Index: /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90	(revision 13071)
+++ /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90	(revision 13072)
@@ -107,4 +107,5 @@
       LOGICAL :: l_trcstat = .FALSE.  !: Produce/do not produce tracer.stat file (T/F)
       LOGICAL :: l_oceout  = .FALSE.  !: Produce all ocean.outputs    (T) or just one (F)
+      LOGICAL :: l_sbcisf  = .FALSE.  !: Print Ice sheet information to ocean.output
       LOGICAL :: l_layout  = .FALSE.  !: Produce all layout.dat files (T) or just one (F)
       LOGICAL :: l_mppout  = .FALSE.  !: Produce/do not produce mpp.output_XXXX files (T/F)
Index: /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 13071)
+++ /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 13072)
@@ -1493,5 +1493,5 @@
             greenland_icesheet_timelapsed = 0.0_wp       
          ENDIF
-         IF(lwp .AND. ll_wrtstp) THEN
+         IF(lwp .AND. ll_wrtstp .AND. sn_cfctl%l_sbcisf ) THEN
             WRITE(numout,*) 'Greenland icesheet mass (kg) read in is ', zgreenland_icesheet_mass_in
             WRITE(numout,*) 'Greenland icesheet mass (kg) used is    ', greenland_icesheet_mass
@@ -1543,5 +1543,5 @@
             antarctica_icesheet_timelapsed = 0.0_wp       
          ENDIF
-         IF(lwp .AND. ll_wrtstp) THEN
+         IF(lwp .AND. ll_wrtstp .AND. sn_cfctl%l_sbcisf ) THEN
             WRITE(numout,*) 'Antarctica icesheet mass (kg) read in is ', zantarctica_icesheet_mass_in
             WRITE(numout,*) 'Antarctica icesheet mass (kg) used is    ', antarctica_icesheet_mass
Index: /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/SBC/sbcisf.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/SBC/sbcisf.F90	(revision 13071)
+++ /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/SBC/sbcisf.F90	(revision 13072)
@@ -274,9 +274,9 @@
 
                ! check
-               IF(lwp .AND. ll_wrtstp) WRITE(numout, *) 'Greenland iceshelf melting climatology (kg/s) : ',zgreenland_fwfisf_sum
+               IF(lwp .AND. ll_wrtstp .AND. sn_cfctl%l_sbcisf) WRITE(numout, *) 'Greenland iceshelf melting climatology (kg/s) : ',zgreenland_fwfisf_sum
 
                zgreenland_fwfisf_sum = glob_sum( fwfisf(:,:) * e1t(:,:) * e2t(:,:) * greenland_icesheet_mask(:,:) )
 
-               IF(lwp .AND. ll_wrtstp) WRITE(numout, *) 'Greenland iceshelf melting adjusted value (kg/s) : ',zgreenland_fwfisf_sum
+               IF(lwp .AND. ll_wrtstp .AND. sn_cfctl%l_sbcisf) WRITE(numout, *) 'Greenland iceshelf melting adjusted value (kg/s) : ',zgreenland_fwfisf_sum
 
                zantarctica_fwfisf_sum = glob_sum( fwfisf(:,:) * e1t(:,:) * e2t(:,:) * antarctica_icesheet_mask(:,:) )
@@ -288,5 +288,5 @@
       
                ! check
-               IF(lwp .AND. ll_wrtstp) WRITE(numout, *) 'Antarctica iceshelf melting climatology (kg/s) : ',zantarctica_fwfisf_sum
+               IF(lwp .AND. ll_wrtstp .AND. sn_cfctl%l_sbcisf) WRITE(numout, *) 'Antarctica iceshelf melting climatology (kg/s) : ',zantarctica_fwfisf_sum
 
                zantarctica_fwfisf_sum = glob_sum( fwfisf(:,:) * e1t(:,:) * e2t(:,:) * antarctica_icesheet_mask(:,:) )
Index: /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 13071)
+++ /branches/UKMO/dev_r5518_GO6_package_isfprint/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 13072)
@@ -540,4 +540,5 @@
          WRITE(numout,*) '                              sn_cfctl%l_trcstat = ', sn_cfctl%l_trcstat
          WRITE(numout,*) '                              sn_cfctl%l_oceout  = ', sn_cfctl%l_oceout
+         WRITE(numout,*) '                              sn_cfctl%l_sbcisf  = ', sn_cfctl%l_sbcisf
          WRITE(numout,*) '                              sn_cfctl%l_layout  = ', sn_cfctl%l_layout
          WRITE(numout,*) '                              sn_cfctl%l_mppout  = ', sn_cfctl%l_mppout
@@ -742,4 +743,5 @@
          sn_cfctl%l_trcstat = setto
       ENDIF
+      sn_cfctl%l_sbcisf  = setto
       sn_cfctl%l_oceout  = setto
       sn_cfctl%l_layout  = setto